#define NUM_CELLS 32
#define NUM_CONFIG_BITS 12
#define NUM_OUTPUT_SEL_BITS 5

typedef struct
{
	Xuint32 cellConfigs[NUM_CELLS];
	Xuint32 outputSel0;
	Xuint32 outputSel1;
	Xuint32 fitness;
} ArrayConfig;

//				Width		Write						Read
// Reg 0		(2)		config Array Num		config Array Num		+ 0
// Reg 1		(5)		config Cell Num		config Cell Num		+ 4
// Reg 2		(12)		config												+ 8	(Increments config cell num)

// Reg 3		(5 + 5)	outputSel 1 & 0									+ 12

// Reg 4		(2)		failMode Array Num	failMode Array Num	+ 16
// Reg 5		(5)		failMode Cell Num		failMode Cell Num		+ 20
// Reg 6		(2)		failMode												+ 24

// Reg 7		(3)		inputSel					inputSel					+ 28
// Reg 8		(4)		vector					vector					+ 32
// Reg 9		(2)		ramData					ramData					+ 36	(Increments vector)

// Reg A		(6 + 6)								output & match			+ 40
// Reg B		(3)		errorReset				error						+ 44

// FTBlock Functions (write)
#define FTBLOCK_writeConfigArrayNum(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR, (Xuint32)(data))

#define FTBLOCK_writeConfigCellNum(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+4, (Xuint32)(data))

#define FTBLOCK_writeConfig(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+8, (Xuint32)(data))

#define FTBLOCK_writeOutputSel(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+12, (Xuint32)(data))

#define FTBLOCK_writeFailModeArrayNum(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+16, (Xuint32)(data))

#define FTBLOCK_writeFailModeCellNum(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+20, (Xuint32)(data))

#define FTBLOCK_writeFailMode(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+24, (Xuint32)(data))

#define FTBLOCK_writeInputSel(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+28, (Xuint32)(data))

#define FTBLOCK_writeVector(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+32, (Xuint32)(data))

#define FTBLOCK_writeTargetRAM(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+36, (Xuint32)(data))

#define FTBLOCK_resetError(data) \
	XIo_Out32(XPAR_OPB_FTBLOCK_0_BASEADDR+44, (Xuint32)(data))

// FTBlock Functions (read)
#define FTBLOCK_readConfigArrayNum()  \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR)

#define FTBLOCK_readConfigCellNum() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+4)

#define FTBLOCK_readOutputSel() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+12)

#define FTBLOCK_readFailModeArrayNum() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+16)

#define FTBLOCK_readFailModeCellNum() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+20)

#define FTBLOCK_readInputSel() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+24)

#define FTBLOCK_readVector() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+32)

#define FTBLOCK_readTargetRAM() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+36)

#define FTBLOCK_readOutputMatch() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+40)

#define FTBLOCK_readError() \
	XIo_In32(XPAR_OPB_FTBLOCK_0_BASEADDR+44)

void configureArray(Xuint32 arrayNum, ArrayConfig *config);
void randomiseArrayConfig(ArrayConfig *config);
